module Text.Safe.Xml
    ( Xml, xml, renderXml, module Text.Safe.Strings )
where

import Text.Safe.Strings

{-
newtype XmlString
    = XmlString { unXmlString :: String }
    deriving Show

instance Language XmlString where
    litfrag  = XmlString
    littext  = XmlString . escapeXml
    natrep   = unXmlString
    language = const "xml"
-}

escapeXml xs =
    concatMap esc xs
  where
    esc '<' = "&lt;"
    esc '&' = "&amp;"
    esc '"' = "&#34;"
    esc x   = [x]

$(declareSafeString "xml" "Xml" [| escapeXml |])
